/** GSWHTMLRawParser - <title>GSWeb: Class GSWHTMLRawParser</title>

   Copyright (C) 2004 Free Software Foundation, Inc.
  
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 	Mar 2004
   
   $Revision: 18891 $
   $Date: 2004-03-25 09:25:48 +0100 (Thu, 25 Mar 2004) $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWHTMLRawParser.h 18891 2004-03-25 08:25:48Z mguesdon $

#ifndef _GSWHTMLRawParser_h__
	#define _GSWHTMLRawParser_h__


//====================================================================
/** 'Raw' HTML Parser
It interpret only dynamic tags (gsweb/wo/oog) and comments
All other text is considered as raw text.
**/
@interface GSWHTMLRawParser : GSWBaseParser
{
  id<GSWTemplateParserDelegate> _delegate; 	/** Delegate **/
  int _textStartIndex;				/** raw text start index **/
  int _textStopIndex;				/** raw text stop index **/
}

+(GSWHTMLRawParser*)parserWithDelegate:(id<GSWTemplateParserDelegate>)delegate
                            htmlString:(NSString*)htmlString;

-(id)initWithDelegate:(id<GSWTemplateParserDelegate>)delegate
           htmlString:(NSString*)htmlString;


/** Parse the html _string and call delegate methods
May raise exception.
**/
-(void)parseHTML;

@end

#endif //_GSWHTMLRawParser_h__

