/** GSWToggle.h - <title>GSWeb: Class GSWToggle</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date: 	Jan 1999
   
   $Revision: 14202 $
   $Date: 2002-07-28 01:48:47 +0200 (Sun, 28 Jul 2002) $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWToggle.h 14202 2002-07-27 23:48:47Z mguesdon $

#ifndef _GSWToggle_h__
	#define _GSWToggle_h__


@interface GSWToggle: GSWDynamicElement
{
  GSWAssociation* _action;
  GSWAssociation* _actionYes;
  GSWAssociation* _actionNo;
  GSWAssociation* _condition;
  GSWAssociation* _disabled;
  NSDictionary* _otherAssociations;
  GSWElement* _children;
};

-(id)initWithName:(NSString*)aName
     associations:(NSDictionary*)associations
         template:(GSWElement*)templateElement;
-(void)dealloc;
-(NSString*)description;
@end

@interface GSWToggle (GSWToggleA)
-(void)appendToResponse:(GSWResponse*)aResponse
              inContext:(GSWContext*)aContext;
-(GSWElement*)invokeActionForRequest:(GSWRequest*)aRequest
                           inContext:(GSWContext*)aContext;
@end

#endif //_GSWToggle_h__
