/** GSWTransactionRecord.h - <title>GSWeb: Class GSWTransactionRecord</title>

   Copyright (C) 1999-2002 Free Software Foundation, Inc.
   
   Written by:	Manuel Guesdon <mguesdon@orange-concept.com>
   Date:        Apr 1999
   
   $Revision: 17030 $
   $Date: 2003-06-25 17:41:19 +0200 (Wed, 25 Jun 2003) $

   This file is part of the GNUstep Web Library.
   
   <license>
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
   
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   </license>
**/

// $Id: GSWTransactionRecord.h 17030 2003-06-25 15:41:19Z mguesdon $

#ifndef _GSWTransactionRecord_h__
	#define _GSWTransactionRecord_h__


//====================================================================
@interface GSWTransactionRecord : NSObject
{
  GSWComponent* _responsePage;
  NSString* _contextID;
  NSString* _senderID;
  NSDictionary* _formValues;
};

+(GSWTransactionRecord*)transactionRecordWithResponsePage:(GSWComponent*)aResponsePage
                                                  context:(GSWContext*)aContext;
-(id)initWithResponsePage:(GSWComponent*)aResponsePage
                  context:(GSWContext*)aContext;

-(id)initWithCoder:(NSCoder*)code;
-(void)encodeWithCoder:(NSCoder*)code;

-(BOOL)isMatchingIDsInContext:(GSWContext*)aContext;
-(void)setResponsePage:(GSWComponent*)aResponsePage;
-(GSWComponent*)responsePage;

@end

#endif //_GSWTransactionRecord_h__
