/* NSPropertyListSerializationTest: 
   test of gnu.gnustep.base.NSPropertyListSerialization

   Copyright (C) 2000 Free Software Foundation, Inc.

   Author:  Nicola Pero <n.pero@mi.flashnet.it>
   Date: October 2000
   
   This file is part of GNUstep.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

import gnu.gnustep.base.*;

class NSPropertyListSerializationTest
{ 
  public static void main (String[] args) 
    throws Throwable
  {
    String string, string_two;
    NSArray array;
    NSDictionary dict;
    NSData data;

    string = "(nicola, luca, ettore)";
    System.out.println ("Created a string " + string);
    array = (NSArray)NSPropertyListSerialization.propertyListFromString 
      (string);
    System.out.println ("* Which gives array: " + array);
    System.out.println ("* Which converted back to string gives: " + 
			NSPropertyListSerialization.stringFromPropertyList 
			(array));
    data = NSPropertyListSerialization.dataFromPropertyList (array);
    System.out.println ("* Which gives data: " + data);
    System.out.println ("* Which converted back to array gives: " + 
			NSPropertyListSerialization.propertyListFromData 
			(data));
    System.out.println ("");

    string = "{ one=uno; two=due; three=tre; }";
    System.out.println ("Created a string " + string);
    dict = (NSDictionary)NSPropertyListSerialization.propertyListFromString 
      (string);
    System.out.println ("* Which gives dictionary: " + dict);
    System.out.println ("* Which converted back to string gives: " + 
			NSPropertyListSerialization.stringFromPropertyList 
			(dict));
    data = NSPropertyListSerialization.dataFromPropertyList (dict);
    System.out.println ("* Which gives data: " + data);
    System.out.println ("* Which converted back to dictionary gives: " + 
			NSPropertyListSerialization.propertyListFromData 
			(data));
    System.out.println ("");

    System.out.println ("test passed (AFAIK)");
  }
}
