/**
    AppKitConstants.m
 
    NOTE: Do not edit this file, it is automaticaly generated.
 
    Copyright (c) 2002 Free Software Foundation
 
    This file is part of the StepTalk project.
 
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
 
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.
 
    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

#import <Foundation/NSArray.h>
#import <Foundation/NSDictionary.h>
#import <Foundation/NSString.h>

#import <AppKit/AppKit.h>
#import <AppKit/AppKitExceptions.h>

#import <AppKit/NSDocument.h>
#import <AppKit/NSHelpManager.h>


NSDictionary *STGetAppKitConstants(void)
{
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    Class numberClass = [NSNumber class];
    IMP numberWithInteger;
    IMP numberWithFloat;
    IMP setObject_forKey;

    SEL numberWithInteger_sel = @selector(numberWithInteger:);
    SEL numberWithFloat_sel = @selector(numberWithFloat:);
    SEL setObject_forKey_sel = @selector(setObject:forKey:);

    numberWithInteger = [numberClass methodForSelector:numberWithInteger_sel];
    numberWithFloat = [numberClass methodForSelector:numberWithFloat_sel];
    setObject_forKey = [dict methodForSelector:setObject_forKey_sel];

#define ADD_id_OBJECT(obj, name) \
            setObject_forKey(dict, setObject_forKey_sel, obj, name)

#define ADD_NSInteger_OBJECT(obj, name) \
            setObject_forKey(dict, setObject_forKey_sel, \
                            numberWithInteger(numberClass, numberWithInteger_sel, obj), \
                            name)

#define ADD_float_OBJECT(obj, name) \
            setObject_forKey(dict, setObject_forKey_sel, \
                            numberWithFloat(numberClass, numberWithFloat_sel, obj), \
                            name)

    ADD_id_OBJECT(NSModalPanelRunLoopMode,@"NSModalPanelRunLoopMode");
    ADD_id_OBJECT(NSEventTrackingRunLoopMode,@"NSEventTrackingRunLoopMode");
    ADD_id_OBJECT(NSFontAttributeName,@"NSFontAttributeName");
    ADD_id_OBJECT(NSParagraphStyleAttributeName,@"NSParagraphStyleAttributeName");
    ADD_id_OBJECT(NSForegroundColorAttributeName,@"NSForegroundColorAttributeName");
    ADD_id_OBJECT(NSUnderlineStyleAttributeName,@"NSUnderlineStyleAttributeName");
    ADD_id_OBJECT(NSSuperscriptAttributeName,@"NSSuperscriptAttributeName");
    ADD_id_OBJECT(NSBackgroundColorAttributeName,@"NSBackgroundColorAttributeName");
    ADD_id_OBJECT(NSAttachmentAttributeName,@"NSAttachmentAttributeName");
    ADD_id_OBJECT(NSLigatureAttributeName,@"NSLigatureAttributeName");
    ADD_id_OBJECT(NSBaselineOffsetAttributeName,@"NSBaselineOffsetAttributeName");
    ADD_id_OBJECT(NSKernAttributeName,@"NSKernAttributeName");
    ADD_id_OBJECT(NSLinkAttributeName,@"NSLinkAttributeName");
    ADD_id_OBJECT(NSAFMAscender,@"NSAFMAscender");
    ADD_id_OBJECT(NSAFMCapHeight,@"NSAFMCapHeight");
    ADD_id_OBJECT(NSAFMCharacterSet,@"NSAFMCharacterSet");
    ADD_id_OBJECT(NSAFMDescender,@"NSAFMDescender");
    ADD_id_OBJECT(NSAFMEncodingScheme,@"NSAFMEncodingScheme");
    ADD_id_OBJECT(NSAFMFamilyName,@"NSAFMFamilyName");
    ADD_id_OBJECT(NSAFMFontName,@"NSAFMFontName");
    ADD_id_OBJECT(NSAFMFormatVersion,@"NSAFMFormatVersion");
    ADD_id_OBJECT(NSAFMFullName,@"NSAFMFullName");
    ADD_id_OBJECT(NSAFMItalicAngle,@"NSAFMItalicAngle");
    ADD_id_OBJECT(NSAFMMappingScheme,@"NSAFMMappingScheme");
    ADD_id_OBJECT(NSAFMNotice,@"NSAFMNotice");
    ADD_id_OBJECT(NSAFMUnderlinePosition,@"NSAFMUnderlinePosition");
    ADD_id_OBJECT(NSAFMUnderlineThickness,@"NSAFMUnderlineThickness");
    ADD_id_OBJECT(NSAFMVersion,@"NSAFMVersion");
    ADD_id_OBJECT(NSAFMWeight,@"NSAFMWeight");
    ADD_id_OBJECT(NSAFMXHeight,@"NSAFMXHeight");
    ADD_id_OBJECT(NSCalibratedWhiteColorSpace,@"NSCalibratedWhiteColorSpace");
    ADD_id_OBJECT(NSCalibratedBlackColorSpace,@"NSCalibratedBlackColorSpace");
    ADD_id_OBJECT(NSCalibratedRGBColorSpace,@"NSCalibratedRGBColorSpace");
    ADD_id_OBJECT(NSDeviceWhiteColorSpace,@"NSDeviceWhiteColorSpace");
    ADD_id_OBJECT(NSDeviceBlackColorSpace,@"NSDeviceBlackColorSpace");
    ADD_id_OBJECT(NSDeviceRGBColorSpace,@"NSDeviceRGBColorSpace");
    ADD_id_OBJECT(NSDeviceCMYKColorSpace,@"NSDeviceCMYKColorSpace");
    ADD_id_OBJECT(NSNamedColorSpace,@"NSNamedColorSpace");
    ADD_id_OBJECT(NSCustomColorSpace,@"NSCustomColorSpace");
    ADD_NSInteger_OBJECT(NSDefaultDepth,@"NSDefaultDepth");
    ADD_NSInteger_OBJECT(NSTwoBitGrayDepth,@"NSTwoBitGrayDepth");
    ADD_NSInteger_OBJECT(NSEightBitGrayDepth,@"NSEightBitGrayDepth");
    ADD_NSInteger_OBJECT(NSEightBitRGBDepth,@"NSEightBitRGBDepth");
    ADD_NSInteger_OBJECT(NSTwelveBitRGBDepth,@"NSTwelveBitRGBDepth");
    ADD_NSInteger_OBJECT(GSSixteenBitRGBDepth,@"GSSixteenBitRGBDepth");
    ADD_NSInteger_OBJECT(NSTwentyFourBitRGBDepth,@"NSTwentyFourBitRGBDepth");
    ADD_float_OBJECT(NSBlack,@"NSBlack");
    ADD_float_OBJECT(NSDarkGray,@"NSDarkGray");
    ADD_float_OBJECT(NSWhite,@"NSWhite");
    ADD_float_OBJECT(NSLightGray,@"NSLightGray");
    ADD_float_OBJECT(NSGray,@"NSGray");
    ADD_id_OBJECT(NSDeviceResolution,@"NSDeviceResolution");
    ADD_id_OBJECT(NSDeviceColorSpaceName,@"NSDeviceColorSpaceName");
    ADD_id_OBJECT(NSDeviceBitsPerSample,@"NSDeviceBitsPerSample");
    ADD_id_OBJECT(NSDeviceIsScreen,@"NSDeviceIsScreen");
    ADD_id_OBJECT(NSDeviceIsPrinter,@"NSDeviceIsPrinter");
    ADD_id_OBJECT(NSDeviceSize,@"NSDeviceSize");
    ADD_id_OBJECT(NSInterfaceStyleDefault,@"NSInterfaceStyleDefault");
    ADD_id_OBJECT(NSColorPboardType,@"NSColorPboardType");
    ADD_id_OBJECT(NSFileContentsPboardType,@"NSFileContentsPboardType");
    ADD_id_OBJECT(NSFilenamesPboardType,@"NSFilenamesPboardType");
    ADD_id_OBJECT(NSFontPboardType,@"NSFontPboardType");
    ADD_id_OBJECT(NSRulerPboardType,@"NSRulerPboardType");
    ADD_id_OBJECT(NSPostScriptPboardType,@"NSPostScriptPboardType");
    ADD_id_OBJECT(NSTabularTextPboardType,@"NSTabularTextPboardType");
    ADD_id_OBJECT(NSRTFPboardType,@"NSRTFPboardType");
    ADD_id_OBJECT(NSRTFDPboardType,@"NSRTFDPboardType");
    ADD_id_OBJECT(NSTIFFPboardType,@"NSTIFFPboardType");
    ADD_id_OBJECT(NSGeneralPboardType,@"NSGeneralPboardType");
    ADD_id_OBJECT(NSDragPboard,@"NSDragPboard");
    ADD_id_OBJECT(NSFindPboard,@"NSFindPboard");
    ADD_id_OBJECT(NSFontPboard,@"NSFontPboard");
    ADD_id_OBJECT(NSGeneralPboard,@"NSGeneralPboard");
    ADD_id_OBJECT(NSRulerPboard,@"NSRulerPboard");
    ADD_id_OBJECT(NSPrintAllPages,@"NSPrintAllPages");
    ADD_id_OBJECT(NSPrintBottomMargin,@"NSPrintBottomMargin");
    ADD_id_OBJECT(NSPrintCopies,@"NSPrintCopies");
    ADD_id_OBJECT(NSPrintFaxCoverSheetName,@"NSPrintFaxCoverSheetName");
    ADD_id_OBJECT(NSPrintFaxHighResolution,@"NSPrintFaxHighResolution");
    ADD_id_OBJECT(NSPrintFaxModem,@"NSPrintFaxModem");
    ADD_id_OBJECT(NSPrintFaxReceiverNames,@"NSPrintFaxReceiverNames");
    ADD_id_OBJECT(NSPrintFaxReceiverNumbers,@"NSPrintFaxReceiverNumbers");
    ADD_id_OBJECT(NSPrintFaxReturnReceipt,@"NSPrintFaxReturnReceipt");
    ADD_id_OBJECT(NSPrintFaxSendTime,@"NSPrintFaxSendTime");
    ADD_id_OBJECT(NSPrintFaxTrimPageEnds,@"NSPrintFaxTrimPageEnds");
    ADD_id_OBJECT(NSPrintFaxUseCoverSheet,@"NSPrintFaxUseCoverSheet");
    ADD_id_OBJECT(NSPrintFirstPage,@"NSPrintFirstPage");
    ADD_id_OBJECT(NSPrintHorizontalPagination,@"NSPrintHorizontalPagination");
    ADD_id_OBJECT(NSPrintHorizontallyCentered,@"NSPrintHorizontallyCentered");
    ADD_id_OBJECT(NSPrintJobDisposition,@"NSPrintJobDisposition");
    ADD_id_OBJECT(NSPrintJobFeatures,@"NSPrintJobFeatures");
    ADD_id_OBJECT(NSPrintLastPage,@"NSPrintLastPage");
    ADD_id_OBJECT(NSPrintLeftMargin,@"NSPrintLeftMargin");
    ADD_id_OBJECT(NSPrintManualFeed,@"NSPrintManualFeed");
    ADD_id_OBJECT(NSPrintOrientation,@"NSPrintOrientation");
    ADD_id_OBJECT(NSPrintPagesPerSheet,@"NSPrintPagesPerSheet");
    ADD_id_OBJECT(NSPrintPaperFeed,@"NSPrintPaperFeed");
    ADD_id_OBJECT(NSPrintPaperName,@"NSPrintPaperName");
    ADD_id_OBJECT(NSPrintPaperSize,@"NSPrintPaperSize");
    ADD_id_OBJECT(NSPrintPrinter,@"NSPrintPrinter");
    ADD_id_OBJECT(NSPrintReversePageOrder,@"NSPrintReversePageOrder");
    ADD_id_OBJECT(NSPrintRightMargin,@"NSPrintRightMargin");
    ADD_id_OBJECT(NSPrintSavePath,@"NSPrintSavePath");
    ADD_id_OBJECT(NSPrintScalingFactor,@"NSPrintScalingFactor");
    ADD_id_OBJECT(NSPrintTopMargin,@"NSPrintTopMargin");
    ADD_id_OBJECT(NSPrintVerticalPagination,@"NSPrintVerticalPagination");
    ADD_id_OBJECT(NSPrintVerticallyCentered,@"NSPrintVerticallyCentered");
    ADD_id_OBJECT(NSPrintCancelJob,@"NSPrintCancelJob");
    ADD_id_OBJECT(NSPrintFaxJob,@"NSPrintFaxJob");
    ADD_id_OBJECT(NSPrintPreviewJob,@"NSPrintPreviewJob");
    ADD_id_OBJECT(NSPrintSaveJob,@"NSPrintSaveJob");
    ADD_id_OBJECT(NSPrintSpoolJob,@"NSPrintSpoolJob");
    ADD_id_OBJECT(NSOldSelectedCharacterRange,@"NSOldSelectedCharacterRange");
    ADD_id_OBJECT(NSPlainFileType,@"NSPlainFileType");
    ADD_id_OBJECT(NSDirectoryFileType,@"NSDirectoryFileType");
    ADD_id_OBJECT(NSApplicationFileType,@"NSApplicationFileType");
    ADD_id_OBJECT(NSFilesystemFileType,@"NSFilesystemFileType");
    ADD_id_OBJECT(NSShellCommandFileType,@"NSShellCommandFileType");
    ADD_id_OBJECT(NSWorkspaceCompressOperation,@"NSWorkspaceCompressOperation");
    ADD_id_OBJECT(NSWorkspaceCopyOperation,@"NSWorkspaceCopyOperation");
    ADD_id_OBJECT(NSWorkspaceDecompressOperation,@"NSWorkspaceDecompressOperation");
    ADD_id_OBJECT(NSWorkspaceDecryptOperation,@"NSWorkspaceDecryptOperation");
    ADD_id_OBJECT(NSWorkspaceDestroyOperation,@"NSWorkspaceDestroyOperation");
    ADD_id_OBJECT(NSWorkspaceDuplicateOperation,@"NSWorkspaceDuplicateOperation");
    ADD_id_OBJECT(NSWorkspaceEncryptOperation,@"NSWorkspaceEncryptOperation");
    ADD_id_OBJECT(NSWorkspaceLinkOperation,@"NSWorkspaceLinkOperation");
    ADD_id_OBJECT(NSWorkspaceMoveOperation,@"NSWorkspaceMoveOperation");
    ADD_id_OBJECT(NSWorkspaceRecycleOperation,@"NSWorkspaceRecycleOperation");
    ADD_NSInteger_OBJECT(NSRunStoppedResponse,@"NSRunStoppedResponse");
    ADD_NSInteger_OBJECT(NSRunAbortedResponse,@"NSRunAbortedResponse");
    ADD_NSInteger_OBJECT(NSRunContinuesResponse,@"NSRunContinuesResponse");
    ADD_NSInteger_OBJECT(GSNoUnderlineStyle,@"GSNoUnderlineStyle");
    ADD_NSInteger_OBJECT(NSSingleUnderlineStyle,@"NSSingleUnderlineStyle");
    ADD_NSInteger_OBJECT(NSButtLineCapStyle,@"NSButtLineCapStyle");
    ADD_NSInteger_OBJECT(NSRoundLineCapStyle,@"NSRoundLineCapStyle");
    ADD_NSInteger_OBJECT(NSSquareLineCapStyle,@"NSSquareLineCapStyle");
    ADD_NSInteger_OBJECT(NSMiterLineJoinStyle,@"NSMiterLineJoinStyle");
    ADD_NSInteger_OBJECT(NSRoundLineJoinStyle,@"NSRoundLineJoinStyle");
    ADD_NSInteger_OBJECT(NSBevelLineJoinStyle,@"NSBevelLineJoinStyle");
    ADD_NSInteger_OBJECT(NSNonZeroWindingRule,@"NSNonZeroWindingRule");
    ADD_NSInteger_OBJECT(NSEvenOddWindingRule,@"NSEvenOddWindingRule");
    ADD_NSInteger_OBJECT(NSMoveToBezierPathElement,@"NSMoveToBezierPathElement");
    ADD_NSInteger_OBJECT(NSLineToBezierPathElement,@"NSLineToBezierPathElement");
    ADD_NSInteger_OBJECT(NSCurveToBezierPathElement,@"NSCurveToBezierPathElement");
    ADD_NSInteger_OBJECT(NSClosePathBezierPathElement,@"NSClosePathBezierPathElement");
    ADD_NSInteger_OBJECT(NSNoTitle,@"NSNoTitle");
    ADD_NSInteger_OBJECT(NSAboveTop,@"NSAboveTop");
    ADD_NSInteger_OBJECT(NSAtTop,@"NSAtTop");
    ADD_NSInteger_OBJECT(NSBelowTop,@"NSBelowTop");
    ADD_NSInteger_OBJECT(NSAboveBottom,@"NSAboveBottom");
    ADD_NSInteger_OBJECT(NSAtBottom,@"NSAtBottom");
    ADD_NSInteger_OBJECT(NSBelowBottom,@"NSBelowBottom");
    ADD_NSInteger_OBJECT(NSTIFFCompressionNone,@"NSTIFFCompressionNone");
    ADD_NSInteger_OBJECT(NSTIFFCompressionCCITTFAX3,@"NSTIFFCompressionCCITTFAX3");
    ADD_NSInteger_OBJECT(NSTIFFCompressionCCITTFAX4,@"NSTIFFCompressionCCITTFAX4");
    ADD_NSInteger_OBJECT(NSTIFFCompressionLZW,@"NSTIFFCompressionLZW");
    ADD_NSInteger_OBJECT(NSTIFFCompressionJPEG,@"NSTIFFCompressionJPEG");
    ADD_NSInteger_OBJECT(NSTIFFCompressionNEXT,@"NSTIFFCompressionNEXT");
    ADD_NSInteger_OBJECT(NSTIFFCompressionPackBits,@"NSTIFFCompressionPackBits");
    ADD_NSInteger_OBJECT(NSTIFFCompressionOldJPEG,@"NSTIFFCompressionOldJPEG");
    ADD_NSInteger_OBJECT(NSTIFFFileType,@"NSTIFFFileType");
    ADD_NSInteger_OBJECT(NSBMPFileType,@"NSBMPFileType");
    ADD_NSInteger_OBJECT(NSGIFFileType,@"NSGIFFileType");
    ADD_NSInteger_OBJECT(NSJPEGFileType,@"NSJPEGFileType");
    ADD_NSInteger_OBJECT(NSPNGFileType,@"NSPNGFileType");
    ADD_NSInteger_OBJECT(NSMomentaryPushButton,@"NSMomentaryPushButton");
    ADD_NSInteger_OBJECT(NSPushOnPushOffButton,@"NSPushOnPushOffButton");
    ADD_NSInteger_OBJECT(NSToggleButton,@"NSToggleButton");
    ADD_NSInteger_OBJECT(NSSwitchButton,@"NSSwitchButton");
    ADD_NSInteger_OBJECT(NSRadioButton,@"NSRadioButton");
    ADD_NSInteger_OBJECT(NSMomentaryChangeButton,@"NSMomentaryChangeButton");
    ADD_NSInteger_OBJECT(NSOnOffButton,@"NSOnOffButton");
    ADD_NSInteger_OBJECT(NSMomentaryLight,@"NSMomentaryLight");
    ADD_NSInteger_OBJECT(NSRoundedBezelStyle,@"NSRoundedBezelStyle");
    ADD_NSInteger_OBJECT(NSRegularSquareBezelStyle,@"NSRegularSquareBezelStyle");
    ADD_NSInteger_OBJECT(NSThickSquareBezelStyle,@"NSThickSquareBezelStyle");
    ADD_NSInteger_OBJECT(NSThickerSquareBezelStyle,@"NSThickerSquareBezelStyle");
    ADD_NSInteger_OBJECT(NSNeXTBezelStyle,@"NSNeXTBezelStyle");
    ADD_NSInteger_OBJECT(NSPushButtonBezelStyle,@"NSPushButtonBezelStyle");
    ADD_NSInteger_OBJECT(NSSmallIconButtonBezelStyle,@"NSSmallIconButtonBezelStyle");
    ADD_NSInteger_OBJECT(NSMediumIconButtonBezelStyle,@"NSMediumIconButtonBezelStyle");
    ADD_NSInteger_OBJECT(NSLargeIconButtonBezelStyle,@"NSLargeIconButtonBezelStyle");
    ADD_NSInteger_OBJECT(NSGradientNone,@"NSGradientNone");
    ADD_NSInteger_OBJECT(NSGradientConcaveWeak,@"NSGradientConcaveWeak");
    ADD_NSInteger_OBJECT(NSGradientConcaveStrong,@"NSGradientConcaveStrong");
    ADD_NSInteger_OBJECT(NSGradientConvexWeak,@"NSGradientConvexWeak");
    ADD_NSInteger_OBJECT(NSGradientConvexStrong,@"NSGradientConvexStrong");
    ADD_NSInteger_OBJECT(NSNullCellType,@"NSNullCellType");
    ADD_NSInteger_OBJECT(NSTextCellType,@"NSTextCellType");
    ADD_NSInteger_OBJECT(NSImageCellType,@"NSImageCellType");
    ADD_NSInteger_OBJECT(NSAnyType,@"NSAnyType");
    ADD_NSInteger_OBJECT(NSIntType,@"NSIntType");
    ADD_NSInteger_OBJECT(NSPositiveIntType,@"NSPositiveIntType");
    ADD_NSInteger_OBJECT(NSFloatType,@"NSFloatType");
    ADD_NSInteger_OBJECT(NSPositiveFloatType,@"NSPositiveFloatType");
    ADD_NSInteger_OBJECT(NSDateType,@"NSDateType");
    ADD_NSInteger_OBJECT(NSDoubleType,@"NSDoubleType");
    ADD_NSInteger_OBJECT(NSPositiveDoubleType,@"NSPositiveDoubleType");
    ADD_NSInteger_OBJECT(NSNoImage,@"NSNoImage");
    ADD_NSInteger_OBJECT(NSImageOnly,@"NSImageOnly");
    ADD_NSInteger_OBJECT(NSImageLeft,@"NSImageLeft");
    ADD_NSInteger_OBJECT(NSImageRight,@"NSImageRight");
    ADD_NSInteger_OBJECT(NSImageBelow,@"NSImageBelow");
    ADD_NSInteger_OBJECT(NSImageAbove,@"NSImageAbove");
    ADD_NSInteger_OBJECT(NSImageOverlaps,@"NSImageOverlaps");
    ADD_NSInteger_OBJECT(NSCellDisabled,@"NSCellDisabled");
    ADD_NSInteger_OBJECT(NSCellState,@"NSCellState");
    ADD_NSInteger_OBJECT(NSPushInCell,@"NSPushInCell");
    ADD_NSInteger_OBJECT(NSCellEditable,@"NSCellEditable");
    ADD_NSInteger_OBJECT(NSChangeGrayCell,@"NSChangeGrayCell");
    ADD_NSInteger_OBJECT(NSCellHighlighted,@"NSCellHighlighted");
    ADD_NSInteger_OBJECT(NSCellLightsByContents,@"NSCellLightsByContents");
    ADD_NSInteger_OBJECT(NSCellLightsByGray,@"NSCellLightsByGray");
    ADD_NSInteger_OBJECT(NSChangeBackgroundCell,@"NSChangeBackgroundCell");
    ADD_NSInteger_OBJECT(NSCellLightsByBackground,@"NSCellLightsByBackground");
    ADD_NSInteger_OBJECT(NSCellIsBordered,@"NSCellIsBordered");
    ADD_NSInteger_OBJECT(NSCellHasOverlappingImage,@"NSCellHasOverlappingImage");
    ADD_NSInteger_OBJECT(NSCellHasImageHorizontal,@"NSCellHasImageHorizontal");
    ADD_NSInteger_OBJECT(NSCellHasImageOnLeftOrBottom,@"NSCellHasImageOnLeftOrBottom");
    ADD_NSInteger_OBJECT(NSCellChangesContents,@"NSCellChangesContents");
    ADD_NSInteger_OBJECT(NSCellIsInsetButton,@"NSCellIsInsetButton");
    ADD_NSInteger_OBJECT(NSCellAllowsMixedState,@"NSCellAllowsMixedState");
    ADD_NSInteger_OBJECT(NSNoCellMask,@"NSNoCellMask");
    ADD_NSInteger_OBJECT(NSContentsCellMask,@"NSContentsCellMask");
    ADD_NSInteger_OBJECT(NSPushInCellMask,@"NSPushInCellMask");
    ADD_NSInteger_OBJECT(NSChangeGrayCellMask,@"NSChangeGrayCellMask");
    ADD_NSInteger_OBJECT(NSChangeBackgroundCellMask,@"NSChangeBackgroundCellMask");
    ADD_NSInteger_OBJECT(NSOffState,@"NSOffState");
    ADD_NSInteger_OBJECT(NSOnState,@"NSOnState");
    ADD_NSInteger_OBJECT(NSMixedState,@"NSMixedState");
    ADD_NSInteger_OBJECT(NSDefaultControlTint,@"NSDefaultControlTint");
    ADD_NSInteger_OBJECT(NSClearControlTint,@"NSClearControlTint");
    ADD_NSInteger_OBJECT(NSGrayModeColorPanel,@"NSGrayModeColorPanel");
    ADD_NSInteger_OBJECT(NSRGBModeColorPanel,@"NSRGBModeColorPanel");
    ADD_NSInteger_OBJECT(NSCMYKModeColorPanel,@"NSCMYKModeColorPanel");
    ADD_NSInteger_OBJECT(NSHSBModeColorPanel,@"NSHSBModeColorPanel");
    ADD_NSInteger_OBJECT(NSCustomPaletteModeColorPanel,@"NSCustomPaletteModeColorPanel");
    ADD_NSInteger_OBJECT(NSColorListModeColorPanel,@"NSColorListModeColorPanel");
    ADD_NSInteger_OBJECT(NSWheelModeColorPanel,@"NSWheelModeColorPanel");
    ADD_NSInteger_OBJECT(NSColorPanelGrayModeMask,@"NSColorPanelGrayModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelRGBModeMask,@"NSColorPanelRGBModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelCMYKModeMask,@"NSColorPanelCMYKModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelHSBModeMask,@"NSColorPanelHSBModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelCustomPaletteModeMask,@"NSColorPanelCustomPaletteModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelColorListModeMask,@"NSColorPanelColorListModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelWheelModeMask,@"NSColorPanelWheelModeMask");
    ADD_NSInteger_OBJECT(NSColorPanelAllModesMask,@"NSColorPanelAllModesMask");
    ADD_NSInteger_OBJECT(GSArrowCursor,@"GSArrowCursor");
    ADD_NSInteger_OBJECT(GSIBeamCursor,@"GSIBeamCursor");
    ADD_NSInteger_OBJECT(NSChangeDone,@"NSChangeDone");
    ADD_NSInteger_OBJECT(NSChangeUndone,@"NSChangeUndone");
    ADD_NSInteger_OBJECT(NSChangeCleared,@"NSChangeCleared");
    ADD_NSInteger_OBJECT(NSSaveOperation,@"NSSaveOperation");
    ADD_NSInteger_OBJECT(NSSaveAsOperation,@"NSSaveAsOperation");
    ADD_NSInteger_OBJECT(NSSaveToOperation,@"NSSaveToOperation");
    ADD_NSInteger_OBJECT(NSDragOperationNone,@"NSDragOperationNone");
    ADD_NSInteger_OBJECT(NSDragOperationCopy,@"NSDragOperationCopy");
    ADD_NSInteger_OBJECT(NSDragOperationLink,@"NSDragOperationLink");
    ADD_NSInteger_OBJECT(NSDragOperationGeneric,@"NSDragOperationGeneric");
    ADD_NSInteger_OBJECT(NSDragOperationPrivate,@"NSDragOperationPrivate");
    ADD_NSInteger_OBJECT(NSDragOperationAll,@"NSDragOperationAll");
    ADD_NSInteger_OBJECT(NSControlGlyph,@"NSControlGlyph");
    ADD_NSInteger_OBJECT(NSNullGlyph,@"NSNullGlyph");
    ADD_NSInteger_OBJECT(NSGlyphBelow,@"NSGlyphBelow");
    ADD_NSInteger_OBJECT(NSGlyphAbove,@"NSGlyphAbove");
    ADD_NSInteger_OBJECT(NSOneByteGlyphPacking,@"NSOneByteGlyphPacking");
    ADD_NSInteger_OBJECT(NSJapaneseEUCGlyphPacking,@"NSJapaneseEUCGlyphPacking");
    ADD_NSInteger_OBJECT(NSAsciiWithDoubleByteEUCGlyphPacking,@"NSAsciiWithDoubleByteEUCGlyphPacking");
    ADD_NSInteger_OBJECT(NSTwoByteGlyphPacking,@"NSTwoByteGlyphPacking");
    ADD_NSInteger_OBJECT(NSFourByteGlyphPacking,@"NSFourByteGlyphPacking");
    ADD_NSInteger_OBJECT(NSItalicFontMask,@"NSItalicFontMask");
    ADD_NSInteger_OBJECT(NSUnitalicFontMask,@"NSUnitalicFontMask");
    ADD_NSInteger_OBJECT(NSBoldFontMask,@"NSBoldFontMask");
    ADD_NSInteger_OBJECT(NSUnboldFontMask,@"NSUnboldFontMask");
    ADD_NSInteger_OBJECT(NSNarrowFontMask,@"NSNarrowFontMask");
    ADD_NSInteger_OBJECT(NSExpandedFontMask,@"NSExpandedFontMask");
    ADD_NSInteger_OBJECT(NSCondensedFontMask,@"NSCondensedFontMask");
    ADD_NSInteger_OBJECT(NSSmallCapsFontMask,@"NSSmallCapsFontMask");
    ADD_NSInteger_OBJECT(NSPosterFontMask,@"NSPosterFontMask");
    ADD_NSInteger_OBJECT(NSCompressedFontMask,@"NSCompressedFontMask");
    ADD_NSInteger_OBJECT(NSNonStandardCharacterSetFontMask,@"NSNonStandardCharacterSetFontMask");
    ADD_NSInteger_OBJECT(NSFixedPitchFontMask,@"NSFixedPitchFontMask");
    ADD_NSInteger_OBJECT(NSNoFontChangeAction,@"NSNoFontChangeAction");
    ADD_NSInteger_OBJECT(NSViaPanelFontAction,@"NSViaPanelFontAction");
    ADD_NSInteger_OBJECT(NSAddTraitFontAction,@"NSAddTraitFontAction");
    ADD_NSInteger_OBJECT(NSRemoveTraitFontAction,@"NSRemoveTraitFontAction");
    ADD_NSInteger_OBJECT(NSSizeUpFontAction,@"NSSizeUpFontAction");
    ADD_NSInteger_OBJECT(NSSizeDownFontAction,@"NSSizeDownFontAction");
    ADD_NSInteger_OBJECT(NSHeavierFontAction,@"NSHeavierFontAction");
    ADD_NSInteger_OBJECT(NSLighterFontAction,@"NSLighterFontAction");
    ADD_NSInteger_OBJECT(NSFPPreviewButton,@"NSFPPreviewButton");
    ADD_NSInteger_OBJECT(NSFPRevertButton,@"NSFPRevertButton");
    ADD_NSInteger_OBJECT(NSFPSetButton,@"NSFPSetButton");
    ADD_NSInteger_OBJECT(NSFPPreviewField,@"NSFPPreviewField");
    ADD_NSInteger_OBJECT(NSFPSizeField,@"NSFPSizeField");
    ADD_NSInteger_OBJECT(NSFPSizeTitle,@"NSFPSizeTitle");
    ADD_NSInteger_OBJECT(NSFPCurrentField,@"NSFPCurrentField");
    ADD_NSInteger_OBJECT(NSFPFamilyBrowser,@"NSFPFamilyBrowser");
    ADD_NSInteger_OBJECT(NSFPFaceBrowser,@"NSFPFaceBrowser");
    ADD_NSInteger_OBJECT(NSFPSizeBrowser,@"NSFPSizeBrowser");
    ADD_NSInteger_OBJECT(NSBackingStoreRetained,@"NSBackingStoreRetained");
    ADD_NSInteger_OBJECT(NSBackingStoreNonretained,@"NSBackingStoreNonretained");
    ADD_NSInteger_OBJECT(NSBackingStoreBuffered,@"NSBackingStoreBuffered");
    ADD_NSInteger_OBJECT(NSCompositeClear,@"NSCompositeClear");
    ADD_NSInteger_OBJECT(NSCompositeCopy,@"NSCompositeCopy");
    ADD_NSInteger_OBJECT(NSCompositeSourceOver,@"NSCompositeSourceOver");
    ADD_NSInteger_OBJECT(NSCompositeSourceIn,@"NSCompositeSourceIn");
    ADD_NSInteger_OBJECT(NSCompositeSourceOut,@"NSCompositeSourceOut");
    ADD_NSInteger_OBJECT(NSCompositeSourceAtop,@"NSCompositeSourceAtop");
    ADD_NSInteger_OBJECT(NSCompositeDestinationOver,@"NSCompositeDestinationOver");
    ADD_NSInteger_OBJECT(NSCompositeDestinationIn,@"NSCompositeDestinationIn");
    ADD_NSInteger_OBJECT(NSCompositeDestinationOut,@"NSCompositeDestinationOut");
    ADD_NSInteger_OBJECT(NSCompositeDestinationAtop,@"NSCompositeDestinationAtop");
    ADD_NSInteger_OBJECT(NSCompositeXOR,@"NSCompositeXOR");
    ADD_NSInteger_OBJECT(NSCompositePlusDarker,@"NSCompositePlusDarker");
    ADD_NSInteger_OBJECT(NSCompositeHighlight,@"NSCompositeHighlight");
    ADD_NSInteger_OBJECT(NSCompositePlusLighter,@"NSCompositePlusLighter");
    ADD_NSInteger_OBJECT(NSWindowAbove,@"NSWindowAbove");
    ADD_NSInteger_OBJECT(NSWindowBelow,@"NSWindowBelow");
    ADD_NSInteger_OBJECT(NSWindowOut,@"NSWindowOut");
    ADD_NSInteger_OBJECT(GSTitleBarKey,@"GSTitleBarKey");
    ADD_NSInteger_OBJECT(GSTitleBarNormal,@"GSTitleBarNormal");
    ADD_NSInteger_OBJECT(GSTitleBarMain,@"GSTitleBarMain");
    ADD_NSInteger_OBJECT(NSScaleProportionally,@"NSScaleProportionally");
    ADD_NSInteger_OBJECT(NSScaleToFit,@"NSScaleToFit");
    ADD_NSInteger_OBJECT(NSScaleNone,@"NSScaleNone");
    ADD_NSInteger_OBJECT(NSImageAlignCenter,@"NSImageAlignCenter");
    ADD_NSInteger_OBJECT(NSImageAlignTop,@"NSImageAlignTop");
    ADD_NSInteger_OBJECT(NSImageAlignTopLeft,@"NSImageAlignTopLeft");
    ADD_NSInteger_OBJECT(NSImageAlignTopRight,@"NSImageAlignTopRight");
    ADD_NSInteger_OBJECT(NSImageAlignLeft,@"NSImageAlignLeft");
    ADD_NSInteger_OBJECT(NSImageAlignBottom,@"NSImageAlignBottom");
    ADD_NSInteger_OBJECT(NSImageAlignBottomLeft,@"NSImageAlignBottomLeft");
    ADD_NSInteger_OBJECT(NSImageAlignBottomRight,@"NSImageAlignBottomRight");
    ADD_NSInteger_OBJECT(NSImageAlignRight,@"NSImageAlignRight");
    ADD_NSInteger_OBJECT(NSImageFrameNone,@"NSImageFrameNone");
    ADD_NSInteger_OBJECT(NSImageFramePhoto,@"NSImageFramePhoto");
    ADD_NSInteger_OBJECT(NSImageFrameGrayBezel,@"NSImageFrameGrayBezel");
    ADD_NSInteger_OBJECT(NSImageFrameGroove,@"NSImageFrameGroove");
    ADD_NSInteger_OBJECT(NSImageFrameButton,@"NSImageFrameButton");
    ADD_NSInteger_OBJECT(NSUtilityWindowMask,@"NSUtilityWindowMask");
    ADD_NSInteger_OBJECT(NSDocModalWindowMask,@"NSDocModalWindowMask");
    ADD_NSInteger_OBJECT(NSOKButton,@"NSOKButton");
    ADD_NSInteger_OBJECT(NSCancelButton,@"NSCancelButton");
    ADD_NSInteger_OBJECT(NSAlertDefaultReturn,@"NSAlertDefaultReturn");
    ADD_NSInteger_OBJECT(NSAlertAlternateReturn,@"NSAlertAlternateReturn");
    ADD_NSInteger_OBJECT(NSAlertOtherReturn,@"NSAlertOtherReturn");
    ADD_NSInteger_OBJECT(NSAlertErrorReturn,@"NSAlertErrorReturn");

    return dict;
}

/* -- End of file -- */
